unitsize(3cm);
defaultpen(fontsize(30));
srand(seconds());

import animation;
import fontsize;

int rows = 5;
int cols = 7;

// Precompute random values
real[] values;
for (int i = 0; i < rows*cols; ++i)
    values.push(unitrand() * 10);

void render_grid(int row_focus, int col_focus) {
    // Add a random number in the middle of each cell
    for (int i = 0; i < rows; ++i) {
        for (int j = 0; j < cols; ++j) {
            real n = values[i * cols + j];
            label(format("%#1.2f", n), (j + 0.5, i + 0.5));
        }
    }

    // Color the focused cell in blue
    fill(box((col_focus, row_focus), (col_focus + 1, row_focus + 1)),
        mediumblue);

    // Color its 4-neighbors in light blue
    int[] row_delta = {0, 0, -1, 1};
    int[] col_delta = {-1, 1, 0, 0};
    for (int i = 0; i < 4; ++i) {
        int row = row_focus + row_delta[i]; 
        int col = col_focus + col_delta[i];
        fill(box((col, row), (col + 1, row + 1)), paleblue);
    }

    // External rectangle
    draw(box((0, 0), (cols, rows)), black+2);

    // Horizontal lines
    for (int i = 1; i < rows; ++i)
        draw((0, i) -- (cols, i));

    // Vertical lines
    for (int i = 1; i < cols; ++i)
        draw((i, 0) -- (i, rows));
}

animation a;
for (int i = rows - 2; i >= 1; --i) {
    for (int j = 1; j < cols - 1; ++j) {
        render_grid(i, j);
        a.add();
        erase();
    }
}

a.movie(delay=600, options="-density 288");
